# Generated by Django 2.0.5 on 2021-06-24 10:40

from django.db import migrations

default_sales_activity_status = [
    {"title": "Open", "is_closed": False, "is_default": True},
    {"title": "Closed", "is_closed": True},
]

default_sales_activity_priority = [
    {"title": "High", "rank": 1, "color": "#ff0000", "is_default": True},
    {"title": "Normal", "rank": 2, "color": "#00ff00", "is_default": False},
    {"title": "Low", "rank": 3, "color": "#808080", "is_default": False},
]


def create_default_sales_activity_status(apps, schema_editor):

    SalesActivityStatus = apps.get_model("sales", "SalesActivityStatusSetting")
    Provider = apps.get_model("accounts", "Provider")

    for provider in Provider.objects.all():
        for sales_activity_status in default_sales_activity_status:
            SalesActivityStatus.objects.update_or_create(
                provider=provider,
                title=sales_activity_status.get("title"),
                defaults=sales_activity_status,
            )


def create_default_sales_activity_priority(apps, schema_editor):

    SalesActivityPriority = apps.get_model("sales", "SalesActivityPrioritySetting")
    Provider = apps.get_model("accounts", "Provider")

    for provider in Provider.objects.all():
        for sales_activity_priority in default_sales_activity_priority:
            SalesActivityPriority.objects.update_or_create(
                provider=provider,
                title=sales_activity_priority.get("title"),
                defaults=sales_activity_priority,
            )


def delete_default_sales_activity_status(apps, schema_editor):
    SalesActivityStatus = apps.get_model("sales", "SalesActivityStatusSetting")
    Provider = apps.get_model("accounts", "Provider")

    for provider in Provider.objects.all():
        for sales_activity_status in default_sales_activity_status:
            SalesActivityStatus.objects.filter(
                provider=provider,
                title=sales_activity_status.get("title"),
            ).delete()


def delete_default_sales_activity_priority(apps, schema_editor):
    SalesActivityPriority = apps.get_model("sales", "SalesActivityPrioritySetting")
    Provider = apps.get_model("accounts", "Provider")

    for provider in Provider.objects.all():
        for sales_activity_priority in default_sales_activity_priority:
            SalesActivityPriority.objects.filter(
                provider=provider,
                title=sales_activity_priority.get("title"),
            ).delete()


class Migration(migrations.Migration):

    dependencies = [("sales", "0002_auto_20210624_1000")]

    operations = [
        migrations.RunPython(
            create_default_sales_activity_status,
            delete_default_sales_activity_status,
        ),
        migrations.RunPython(
            create_default_sales_activity_priority,
            delete_default_sales_activity_priority,
        ),
    ]
